wxWidgets: wxListCtrl Class Reference

| Version: 3.1.5

Loading...
Searching...
No Matches
Public Member Functions | Protected Member Functions | List of all members
wxListCtrl Class Reference
Class List by Category » Controls

`#include </cygdrive/c/Users/Hamis/Cygwin-packaging/wxWidgets3.1/wxWidgets3.1-3.1.5-3.x86_64/src/wxWidgets-3.1.5/interface/wx/listctrl.h>`

Inheritance diagram for wxListCtrl:
[legend]

## Detailed Description

A list control presents lists in a number of formats: list view, report view, icon view and small icon view.

In any case, elements are numbered from zero. For all these modes, the items are stored in the control and must be added to it using wxListCtrl::InsertItem method.

A special case of report view quite different from the other modes of the list control is a virtual control in which the items data (including text, images and attributes) is managed by the main program and is requested by the control itself only when needed which allows having controls with millions of items without consuming much memory. To use virtual list control you must use wxListCtrl::SetItemCount first and override at least wxListCtrl::OnGetItemText (and optionally wxListCtrl::OnGetItemImage or wxListCtrl::OnGetItemColumnImage and wxListCtrl::OnGetItemAttr) to return the information about the items when the control requests it.

Virtual list control can be used as a normal one except that no operations which can take time proportional to the number of items in the control happen – this is required to allow having a practically infinite number of items. For example, in a multiple selection virtual list control, the selections won't be sent when many items are selected at once because this could mean iterating over all the items.

Using many of wxListCtrl features is shown in the corresponding sample.

To intercept events from a list control, use the event table macros described in wxListEvent.

wxMac Note: Starting with wxWidgets 2.8, wxListCtrl uses a native implementation for report mode, and uses a generic implementation for other modes. You can use the generic implementation for report mode as well by setting the `mac.listctrl.always_use_generic` system option (see wxSystemOptions) to 1.

## Styles

This class supports the following styles:

- wxLC_LIST:
  Multicolumn list view, with optional small icons. Columns are computed automatically, i.e. you don't set columns as in `wxLC_REPORT`. In other words, the list wraps, unlike a wxListBox.
- wxLC_REPORT:
  Single or multicolumn report view, with optional header.
- wxLC_VIRTUAL:
  The application provides items text on demand. May only be used with `wxLC_REPORT`.
- wxLC_ICON:
  Large icon view, with optional labels.
- wxLC_SMALL_ICON:
  Small icon view, with optional labels.
- wxLC_ALIGN_TOP:
  Icons align to the top. Win32 default, Win32 only.
- wxLC_ALIGN_LEFT:
  Icons align to the left.
- wxLC_AUTOARRANGE:
  Icons arrange themselves. Win32 only.
- wxLC_EDIT_LABELS:
  Labels are editable: the application will be notified when editing starts.
- wxLC_NO_HEADER:
  No header in report mode.
- wxLC_SINGLE_SEL:
  Single selection (default is multiple).
- wxLC_SORT_ASCENDING:
  Sort in ascending order. (You must still supply a comparison callback in wxListCtrl::SortItems.)
- wxLC_SORT_DESCENDING:
  Sort in descending order. (You must still supply a comparison callback in wxListCtrl::SortItems.)
- wxLC_HRULES:
  Draws light horizontal rules between rows in report mode.
- wxLC_VRULES:
  Draws light vertical rules between columns in report mode.

## Events emitted by this class

The following event handler macros redirect the events to member function handlers 'func' with prototypes like:

void handlerFuncName(wxListEvent& event)

Event macros for events emitted by this class:

- EVT_LIST_BEGIN_DRAG(id, func):
  Begin dragging with the left mouse button. Processes a `wxEVT_LIST_BEGIN_DRAG` event type.
- EVT_LIST_BEGIN_RDRAG(id, func):
  Begin dragging with the right mouse button. Processes a `wxEVT_LIST_BEGIN_RDRAG` event type.
- EVT_LIST_BEGIN_LABEL_EDIT(id, func):
  Begin editing a label. This can be prevented by calling Veto(). Processes a `wxEVT_LIST_BEGIN_LABEL_EDIT` event type.
- EVT_LIST_END_LABEL_EDIT(id, func):
  Finish editing a label. This can be prevented by calling Veto(). Processes a `wxEVT_LIST_END_LABEL_EDIT` event type.
- EVT_LIST_DELETE_ITEM(id, func):
  An item was deleted. Processes a `wxEVT_LIST_DELETE_ITEM` event type.
- EVT_LIST_DELETE_ALL_ITEMS(id, func):
  All items were deleted. Processes a `wxEVT_LIST_DELETE_ALL_ITEMS` event type.
- EVT_LIST_ITEM_SELECTED(id, func):
  The item has been selected. Notice that the mouse is captured by the control itself when this event is generated, see event handling overview. Processes a `wxEVT_LIST_ITEM_SELECTED` event type.
- EVT_LIST_ITEM_DESELECTED(id, func):
  The item has been deselected. Processes a `wxEVT_LIST_ITEM_DESELECTED` event type.
- EVT_LIST_ITEM_ACTIVATED(id, func):
  The item has been activated (ENTER or double click). Processes a `wxEVT_LIST_ITEM_ACTIVATED` event type.
- EVT_LIST_ITEM_FOCUSED(id, func):
  The currently focused item has changed. Processes a `wxEVT_LIST_ITEM_FOCUSED` event type.
- EVT_LIST_ITEM_MIDDLE_CLICK(id, func):
  The middle mouse button has been clicked on an item. This is only supported by the generic control. Processes a `wxEVT_LIST_ITEM_MIDDLE_CLICK` event type.
- EVT_LIST_ITEM_RIGHT_CLICK(id, func):
  The right mouse button has been clicked on an item. Processes a `wxEVT_LIST_ITEM_RIGHT_CLICK` event type.
- EVT_LIST_KEY_DOWN(id, func):
  A key has been pressed. Processes a `wxEVT_LIST_KEY_DOWN` event type.
- EVT_LIST_INSERT_ITEM(id, func):
  An item has been inserted. Processes a `wxEVT_LIST_INSERT_ITEM` event type.
- EVT_LIST_COL_CLICK(id, func):
  A column (m_col) has been left-clicked. Processes a `wxEVT_LIST_COL_CLICK` event type.
- EVT_LIST_COL_RIGHT_CLICK(id, func):
  A column (m_col) has been right-clicked. Processes a `wxEVT_LIST_COL_RIGHT_CLICK` event type.
- EVT_LIST_COL_BEGIN_DRAG(id, func):
  The user started resizing a column - can be vetoed. Processes a `wxEVT_LIST_COL_BEGIN_DRAG` event type.
- EVT_LIST_COL_DRAGGING(id, func):
  The divider between columns is being dragged. Processes a `wxEVT_LIST_COL_DRAGGING` event type.
- EVT_LIST_COL_END_DRAG(id, func):
  A column has been resized by the user. Processes a `wxEVT_LIST_COL_END_DRAG` event type.
- EVT_LIST_CACHE_HINT(id, func):
  Prepare cache for a virtual list control. Processes a `wxEVT_LIST_CACHE_HINT` event type.
- EVT_LIST_ITEM_CHECKED(id, func):
  The item has been checked. Processes a `wxEVT_LIST_ITEM_CHECKED` event type (new since wxWidgets 3.1.0).
- EVT_LIST_ITEM_UNCHECKED(id, func):
  The item has been unchecked. Processes a `wxEVT_LIST_ITEM_UNCHECKED` event type (new since wxWidgets 3.1.0).
  Note
    Under wxMSW this control uses wxSystemThemedControl for an explorer style appearance by default since wxWidgets 3.1.0. If this is not desired, you can call wxSystemThemedControl::EnableSystemTheme with `false` argument to disable this.

  ##

Library: wxCore

<>< =''>:</>&;&;< =''>\ </></>

Appearance:

wxMSW Appearance | wxGTK Appearance | wxOSX Appearance

See also
  wxListCtrl Overview, wxListView, wxListBox, wxTreeCtrl, wxImageList, wxListEvent, wxListItem, wxEditableListBox

## Public Member Functions
| wxListCtrl ()
| Default constructor.
| wxListCtrl (wxWindow *parent, wxWindowID id, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=wxLC_ICON, const wxValidator &validator=wxDefaultValidator, const wxString &name=wxListCtrlNameStr)
| Constructor, creating and showing a list control.
virtual | ~wxListCtrl ()
| Destructor, destroying the list control.
long | AppendColumn (const wxString &heading, wxListColumnFormat format=wxLIST_FORMAT_LEFT, int width=-1)
| Adds a new column to the list control in report view mode.
bool | Arrange (int flag=wxLIST_ALIGN_DEFAULT)
| Arranges the items in icon or small icon view.
void | AssignImageList (wxImageList *imageList, int which)
| Sets the image list associated with the control and takes ownership of it (i.e.
void | ClearAll ()
| Deletes all items and all columns.
bool | Create (wxWindow *parent, wxWindowID id, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=wxLC_ICON, const wxValidator &validator=wxDefaultValidator, const wxString &name=wxListCtrlNameStr)
| Creates the list control.
bool | DeleteAllColumns ()
| Delete all columns in the list control.
bool | DeleteAllItems ()
| Deletes all items in the list control.
bool | DeleteColumn (int col)
| Deletes a column.
bool | DeleteItem (long item)
| Deletes the specified item.
wxTextCtrl * | EditLabel (long item, wxClassInfo *textControlClass=wxCLASSINFO(wxTextCtrl))
| Starts editing the label of the given item.
void | EnableAlternateRowColours (bool enable=true)
| Enable alternating row background colours (also called zebra striping).
void | EnableBellOnNoMatch (bool on=true)
| Enable or disable a beep if there is no match for the currently entered text when searching for the item from keyboard.
bool | EndEditLabel (bool cancel)
| Finish editing the label.
bool | EnsureVisible (long item)
| Ensures this item is visible.
long | FindItem (long start, const wxString &str, bool partial=false)
| Find an item whose label matches this string, starting from start or the beginning if start is `-1`.
long | FindItem (long start, wxUIntPtr data)
| Find an item whose data matches this data, starting from start or the beginning if 'start' is `-1`.
long | FindItem (long start, const wxPoint &pt, int direction)
| Find an item nearest this position in the specified direction, starting from start or the beginning if start is -1.
bool | GetColumn (int col, wxListItem &item) const
| Gets information about this column.
int | GetColumnCount () const
| Returns the number of columns.
int | GetColumnIndexFromOrder (int pos) const
| Gets the column index from its position in visual order.
int | GetColumnOrder (int col) const
| Gets the column visual order position.
int | GetColumnWidth (int col) const
| Gets the column width (report view only).
wxArrayInt | GetColumnsOrder () const
| Returns the array containing the orders of all columns.
int | GetCountPerPage () const
| Gets the number of items that can fit vertically in the visible area of the list control (list or report view) or the total number of items in the list control (icon or small icon view).
wxTextCtrl * | GetEditControl () const
| Returns the edit control being currently used to edit a label.
wxImageList * | GetImageList (int which) const
| Returns the specified image list.
bool | GetItem (wxListItem &info) const
| Gets information about the item.
wxColour | GetItemBackgroundColour (long item) const
| Returns the colour for this item.
int | GetItemCount () const
| Returns the number of items in the list control.
wxUIntPtr | GetItemData (long item) const
| Gets the application-defined data associated with this item.
wxFont | GetItemFont (long item) const
| Returns the item's font.
bool | GetItemPosition (long item, wxPoint &pos) const
| Returns the position of the item, in icon or small icon view.
bool | GetItemRect (long item, wxRect &rect, int code=wxLIST_RECT_BOUNDS) const
| Returns the rectangle representing the item's size and position, in physical coordinates.
wxSize | GetItemSpacing () const
| Retrieves the spacing between icons in pixels: horizontal spacing is returned as `x` component of the wxSize object and the vertical spacing as its `y` component.
int | GetItemState (long item, long stateMask) const
| Gets the item state.
wxString | GetItemText (long item, int col=0) const
| Gets the item text for this item.
wxColour | GetItemTextColour (long item) const
| Returns the colour for this item.
long | GetNextItem (long item, int geometry=wxLIST_NEXT_ALL, int state=wxLIST_STATE_DONTCARE) const
| Searches for an item with the given geometry or state, starting from item but excluding the item itself.
int | GetSelectedItemCount () const
| Returns the number of selected items in the list control.
bool | GetSubItemRect (long item, long subItem, wxRect &rect, int code=wxLIST_RECT_BOUNDS) const
| Returns the rectangle representing the size and position, in physical coordinates, of the given subitem, i.e.
wxColour | GetTextColour () const
| Gets the text colour of the list control.
long | GetTopItem () const
| Gets the index of the topmost visible item when in list or report view.
wxRect | GetViewRect () const
| Returns the rectangle taken by all items in the control.
void | SetAlternateRowColour (const wxColour &colour)
| Set the alternative row background colour to a specific colour.
wxColour | GetAlternateRowColour () const
| Get the alternative row background colour.
long | HitTest (const wxPoint &point, int &flags, long *ptrSubItem=NULL) const
| Determines which item (if any) is at the specified point, giving details in flags.
bool | InReportView () const
| Returns true if the control is currently using wxLC_REPORT style.
long | InsertColumn (long col, const wxListItem &info)
| For report view mode (only), inserts a column.
long | InsertColumn (long col, const wxString &heading, int format=wxLIST_FORMAT_LEFT, int width=wxLIST_AUTOSIZE)
| For report view mode (only), inserts a column.
long | InsertItem (wxListItem &info)
| Inserts an item, returning the index of the new item if successful, -1 otherwise.
long | InsertItem (long index, const wxString &label)
| Insert a string item.
long | InsertItem (long index, int imageIndex)
| Insert an image item.
long | InsertItem (long index, const wxString &label, int imageIndex)
| Insert an image/string item.
bool | IsEmpty () const
| Returns true if the control doesn't currently contain any items.
bool | IsVirtual () const
| Returns true if the control is currently in virtual report view.
void | RefreshItem (long item)
| Redraws the given item.
void | RefreshItems (long itemFrom, long itemTo)
| Redraws the items between itemFrom and itemTo.
bool | ScrollList (int dx, int dy)
| Scrolls the list control.
virtual bool | SetBackgroundColour (const wxColour &col)
| Sets the background colour.
bool | SetColumn (int col, wxListItem &item)
| Sets information about this column.
bool | SetColumnWidth (int col, int width)
| Sets the column width.
bool | SetColumnsOrder (const wxArrayInt &orders)
| Changes the order in which the columns are shown.
bool | SetHeaderAttr (const wxItemAttr &attr)
| Change the font and the colours used for the list control header.
void | SetImageList (wxImageList *imageList, int which)
| Sets the image list associated with the control.
bool | IsVisible (long item) const
| Check if the item is visible.
bool | SetItem (wxListItem &info)
| Sets the data of an item.
bool | SetItem (long index, int column, const wxString &label, int imageId=-1)
| Sets an item string field at a particular column.
void | SetItemBackgroundColour (long item, const wxColour &col)
| Sets the background colour for this item.
bool | SetItemColumnImage (long item, long column, int image)
| Sets the image associated with the item.
void | SetItemCount (long count)
| This method can only be used with virtual list controls.
bool | SetItemData (long item, long data)
| Associates application-defined data with this item.
void | SetItemFont (long item, const wxFont &font)
| Sets the item's font.
bool | SetItemImage (long item, int image, int selImage=-1)
| Sets the unselected and selected images associated with the item.
bool | SetItemPosition (long item, const wxPoint &pos)
| Sets the position of the item, in icon or small icon view.
bool | SetItemPtrData (long item, wxUIntPtr data)
| Associates application-defined data with this item.
bool | SetItemState (long item, long state, long stateMask)
| Sets the item state.
void | SetItemText (long item, const wxString &text)
| Sets the item text for this item.
void | SetItemTextColour (long item, const wxColour &col)
| Sets the colour for this item.
void | SetSingleStyle (long style, bool add=true)
| Adds or removes a single window style.
void | SetTextColour (const wxColour &col)
| Sets the text colour of the list control.
void | SetWindowStyleFlag (long style)
| Sets the whole window style, deleting all items.
bool | SortItems (wxListCtrlCompare fnSortCallBack, wxIntPtr data)
| Call this function to sort the items in the list control.
bool | HasCheckBoxes () const
| Returns true if checkboxes are enabled for list items.
bool | EnableCheckBoxes (bool enable=true)
| Enable or disable checkboxes for list items.
bool | IsItemChecked (long item) const
| Return true if the checkbox for the given wxListItem is checked.
void | CheckItem (long item, bool check)
| Check or uncheck a wxListItem in a control using checkboxes.
void | ExtendRulesAndAlternateColour (bool extend=true)
| Extend rules and alternate rows background to the entire client area.
Public Member Functions inherited from wxControl
| wxControl (wxWindow *parent, wxWindowID id, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=0, const wxValidator &validator=wxDefaultValidator, const wxString &name=wxControlNameStr)
| Constructs a control.
| wxControl ()
| Default constructor to allow 2-phase creation.
bool | Create (wxWindow *parent, wxWindowID id, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=0, const wxValidator &validator=wxDefaultValidator, const wxString &name=wxControlNameStr)
virtual void | Command (wxCommandEvent &event)
| Simulates the effect of the user issuing a command to the item.
wxString | GetLabel () const
| Returns the control's label, as it was passed to SetLabel().
wxString | GetLabelText () const
| Returns the control's label without mnemonics.
wxSize | GetSizeFromTextSize (int xlen, int ylen=-1) const
| Determine the size needed by the control to leave the given area for its text.
wxSize | GetSizeFromTextSize (const wxSize &tsize) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
wxSize | GetSizeFromText (const wxString &text) const
| Determine the minimum size needed by the control to display the given text.
void | SetLabel (const wxString &label)
| Sets the control's label.
void | SetLabelText (const wxString &text)
| Sets the control's label to exactly the given string.
bool | SetLabelMarkup (const wxString &markup)
| Sets the controls label to a string using markup.
Public Member Functions inherited from wxWindow
| wxWindow ()
| Default constructor.
| wxWindow (wxWindow *parent, wxWindowID id, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=0, const wxString &name=wxPanelNameStr)
| Constructs a window, which can be a child of a frame, dialog or any other non-control window.
virtual | ~wxWindow ()
| Destructor.
bool | Create (wxWindow *parent, wxWindowID id, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=0, const wxString &name=wxPanelNameStr)
| Construct the actual window object after creating the C++ object.
virtual bool | AcceptsFocus () const
| This method may be overridden in the derived classes to return false to indicate that this control doesn't accept input at all (i.e. behaves like e.g. wxStaticText) and so doesn't need focus.
virtual bool | AcceptsFocusFromKeyboard () const
| This method may be overridden in the derived classes to return false to indicate that while this control can, in principle, have focus if the user clicks it with the mouse, it shouldn't be included in the TAB traversal chain when using the keyboard.
virtual bool | AcceptsFocusRecursively () const
| Overridden to indicate whether this window or one of its children accepts focus.
void | DisableFocusFromKeyboard ()
| Disable giving focus to this window using the keyboard navigation keys.
bool | IsFocusable () const
| Can this window itself have focus?
bool | CanAcceptFocus () const
| Can this window have focus right now?
bool | CanAcceptFocusFromKeyboard () const
| Can this window be assigned focus from keyboard right now?
virtual bool | HasFocus () const
| Returns true if the window (or in case of composite controls, its main child window) has focus.
virtual void | SetCanFocus (bool canFocus)
| This method is only implemented by ports which have support for native TAB traversal (such as GTK+ 2.0).
virtual void | EnableVisibleFocus (bool enable)
| Enables or disables visible indication of keyboard focus.
virtual void | SetFocus ()
| This sets the window to receive keyboard input.
virtual void | SetFocusFromKbd ()
| This function is called by wxWidgets keyboard navigation code when the user gives the focus to this window from keyboard (e.g. using `TAB` key).
virtual void | AddChild (wxWindow *child)
| Adds a child window.
bool | DestroyChildren ()
| Destroys all children of a window.
wxWindow * | FindWindow (long id) const
| Find a child of this window, by id.
wxWindow * | FindWindow (const wxString &name) const
| Find a child of this window, by name.
wxWindowList & | GetChildren ()
| Returns a reference to the list of the window's children.
const wxWindowList & | GetChildren () const
| Returns a const reference to the list of the window's children.
virtual void | RemoveChild (wxWindow *child)
| Removes a child window.
wxWindow * | GetGrandParent () const
| Returns the grandparent of a window, or NULL if there isn't one.
wxWindow * | GetNextSibling () const
| Returns the next window after this one among the parent's children or NULL if this window is the last child.
wxWindow * | GetParent () const
| Returns the parent of the window, or NULL if there is no parent.
wxWindow * | GetPrevSibling () const
| Returns the previous window before this one among the parent's children or `NULL` if this window is the first child.
bool | IsDescendant (wxWindow *win) const
| Check if the specified window is a descendant of this one.
virtual bool | Reparent (wxWindow *newParent)
| Reparents the window, i.e. the window will be removed from its current parent window (e.g.
virtual void | AlwaysShowScrollbars (bool hflag=true, bool vflag=true)
| Call this function to force one or both scrollbars to be always shown, even if the window is big enough to show its entire contents without scrolling.
virtual int | GetScrollPos (int orientation) const
| Returns the built-in scrollbar position.
virtual int | GetScrollRange (int orientation) const
| Returns the built-in scrollbar range.
virtual int | GetScrollThumb (int orientation) const
| Returns the built-in scrollbar thumb size.
bool | CanScroll (int orient) const
| Returns true if this window can have a scroll bar in this orientation.
bool | HasScrollbar (int orient) const
| Returns true if this window currently has a scroll bar for this orientation.
virtual bool | IsScrollbarAlwaysShown (int orient) const
| Return whether a scrollbar is always shown.
virtual bool | ScrollLines (int lines)
| Scrolls the window by the given number of lines down (if lines is positive) or up.
virtual bool | ScrollPages (int pages)
| Scrolls the window by the given number of pages down (if pages is positive) or up.
virtual void | ScrollWindow (int dx, int dy, const wxRect *rect=NULL)
| Physically scrolls the pixels in the window and move child windows accordingly.
bool | LineUp ()
| Same as ScrollLines (-1).
bool | LineDown ()
| Same as ScrollLines (1).
bool | PageUp ()
| Same as ScrollPages (-1).
bool | PageDown ()
| Same as ScrollPages (1).
virtual void | SetScrollPos (int orientation, int pos, bool refresh=true)
| Sets the position of one of the built-in scrollbars.
virtual void | SetScrollbar (int orientation, int position, int thumbSize, int range, bool refresh=true)
| Sets the scrollbar properties of a built-in scrollbar.
void | Center (int dir=wxBOTH)
| A synonym for Centre().
void | CenterOnParent (int dir=wxBOTH)
| A synonym for CentreOnParent().
void | Centre (int direction=wxBOTH)
| Centres the window.
void | CentreOnParent (int direction=wxBOTH)
| Centres the window on its parent.
void | GetPosition (int *x, int *y) const
| This gets the position of the window in pixels, relative to the parent window for the child windows or relative to the display origin for the top level windows.
wxPoint | GetPosition () const
| This gets the position of the window in pixels, relative to the parent window for the child windows or relative to the display origin for the top level windows.
wxRect | GetRect () const
| Returns the position and size of the window as a wxRect object.
void | GetScreenPosition (int *x, int *y) const
| Returns the window position in screen coordinates, whether the window is a child window or a top level one.
wxPoint | GetScreenPosition () const
| Returns the window position in screen coordinates, whether the window is a child window or a top level one.
wxRect | GetScreenRect () const
| Returns the position and size of the window on the screen as a wxRect object.
virtual wxPoint | GetClientAreaOrigin () const
| Get the origin of the client area of the window relative to the window top left corner (the client area may be shifted because of the borders, scrollbars, other decorations...).
wxRect | GetClientRect () const
| Get the client rectangle in window (i.e. client) coordinates.
void | Move (int x, int y, int flags=wxSIZE_USE_EXISTING)
| Moves the window to the given position.
void | Move (const wxPoint &pt, int flags=wxSIZE_USE_EXISTING)
| Moves the window to the given position.
void | SetPosition (const wxPoint &pt)
| Moves the window to the specified position.
void | ClientToScreen (int *x, int *y) const
| Converts to screen coordinates from coordinates relative to this window.
wxPoint | ClientToScreen (const wxPoint &pt) const
| Converts to screen coordinates from coordinates relative to this window.
wxPoint | ConvertDialogToPixels (const wxPoint &pt) const
| Converts a point or size from dialog units to pixels.
wxSize | ConvertDialogToPixels (const wxSize &sz) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
wxPoint | ConvertPixelsToDialog (const wxPoint &pt) const
| Converts a point or size from pixels to dialog units.
wxSize | ConvertPixelsToDialog (const wxSize &sz) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | ScreenToClient (int *x, int *y) const
| Converts from screen to client window coordinates.
wxPoint | ScreenToClient (const wxPoint &pt) const
| Converts from screen to client window coordinates.
virtual void | ClearBackground ()
| Clears the window by filling it with the current background colour.
void | Freeze ()
| Freezes the window or, in other words, prevents any updates from taking place on screen, the window is not redrawn at all.
void | Thaw ()
| Re-enables window updating after a previous call to Freeze().
bool | IsFrozen () const
| Returns true if the window is currently frozen by a call to Freeze().
wxColour | GetBackgroundColour () const
| Returns the background colour of the window.
virtual wxBackgroundStyle | GetBackgroundStyle () const
| Returns the background style of the window.
virtual int | GetCharHeight () const
| Returns the character height for this window.
virtual int | GetCharWidth () const
| Returns the average character width for this window.
virtual wxVisualAttributes | GetDefaultAttributes () const
| Currently this is the same as calling wxWindow::GetClassDefaultAttributes(wxWindow::GetWindowVariant()).
virtual wxSize | GetDPI () const
| Return the DPI of the display used by this window.
wxFont | GetFont () const
| Returns the font for this window.
wxColour | GetForegroundColour () const
| Returns the foreground colour of the window.
void | GetTextExtent (const wxString &string, int *w, int *h, int *descent=NULL, int *externalLeading=NULL, const wxFont *font=NULL) const
| Gets the dimensions of the string as it would be drawn on the window with the currently selected font.
wxSize | GetTextExtent (const wxString &string) const
| Gets the dimensions of the string as it would be drawn on the window with the currently selected font.
const wxRegion & | GetUpdateRegion () const
| Returns the region specifying which parts of the window have been damaged.
wxRect | GetUpdateClientRect () const
| Get the update rectangle bounding box in client coords.
virtual bool | HasTransparentBackground ()
| Returns true if this window background is transparent (as, for example, for wxStaticText) and should show the parent window background.
virtual void | Refresh (bool eraseBackground=true, const wxRect *rect=NULL)
| Causes this window, and all of its children recursively (except under wxGTK1 where this is not implemented), to be repainted.
void | RefreshRect (const wxRect &rect, bool eraseBackground=true)
| Redraws the contents of the given rectangle: only the area inside it will be repainted.
virtual void | Update ()
| Calling this method immediately repaints the invalidated area of the window and all of its children recursively (this normally only happens when the flow of control returns to the event loop).
virtual bool | SetBackgroundStyle (wxBackgroundStyle style)
| Sets the background style of the window.
virtual bool | IsTransparentBackgroundSupported (wxString *reason=NULL) const
| Checks whether using transparent background might work.
virtual bool | SetFont (const wxFont &font)
| Sets the font for this window.
virtual bool | SetForegroundColour (const wxColour &colour)
| Sets the foreground colour of the window.
void | SetOwnBackgroundColour (const wxColour &colour)
| Sets the background colour of the window but prevents it from being inherited by the children of this window.
bool | InheritsBackgroundColour () const
| Return true if this window inherits the background colour from its parent.
bool | UseBgCol () const
| Return true if a background colour has been set for this window.
bool | UseBackgroundColour () const
| Return true if a background colour has been set for this window.
void | SetOwnFont (const wxFont &font)
| Sets the font of the window but prevents it from being inherited by the children of this window.
void | SetOwnForegroundColour (const wxColour &colour)
| Sets the foreground colour of the window but prevents it from being inherited by the children of this window.
bool | UseForegroundColour () const
| Return true if a foreground colour has been set for this window.
bool | InheritsForegroundColour () const
| Return true if this window inherits the foreground colour from its parent.
void | SetPalette (const wxPalette &pal)
virtual bool | ShouldInheritColours () const
| Return true from here to allow the colours of this window to be changed by InheritAttributes().
virtual void | SetThemeEnabled (bool enable)
| This function tells a window if it should use the system's "theme" code to draw the windows' background instead of its own background drawing code.
virtual bool | GetThemeEnabled () const
| Returns true if the window uses the system theme for drawing its background.
virtual bool | CanSetTransparent ()
| Returns true if the system supports transparent windows and calling SetTransparent() may succeed.
virtual bool | SetTransparent (wxByte alpha)
| Set the transparency of the window.
wxEvtHandler * | GetEventHandler () const
| Returns the event handler for this window.
bool | HandleAsNavigationKey (const wxKeyEvent &event)
| This function will generate the appropriate call to Navigate() if the key event is one normally used for keyboard navigation and return true in this case.
bool | HandleWindowEvent (wxEvent &event) const
| Shorthand for:
bool | ProcessWindowEvent (wxEvent &event)
| Convenient wrapper for ProcessEvent().
bool | ProcessWindowEventLocally (wxEvent &event)
| Wrapper for wxEvtHandler::ProcessEventLocally().
wxEvtHandler * | PopEventHandler (bool deleteHandler=false)
| Removes and returns the top-most event handler on the event handler stack.
void | PushEventHandler (wxEvtHandler *handler)
| Pushes this event handler onto the event stack for the window.
bool | RemoveEventHandler (wxEvtHandler *handler)
| Find the given handler in the windows event handler stack and removes (but does not delete) it from the stack.
void | SetEventHandler (wxEvtHandler *handler)
| Sets the event handler for this window.
virtual void | SetNextHandler (wxEvtHandler *handler)
| wxWindows cannot be used to form event handler chains; this function thus will assert when called.
virtual void | SetPreviousHandler (wxEvtHandler *handler)
| wxWindows cannot be used to form event handler chains; this function thus will assert when called.
long | GetExtraStyle () const
| Returns the extra style bits for the window.
virtual long | GetWindowStyleFlag () const
| Gets the window style that was passed to the constructor or Create() method.
long | GetWindowStyle () const
| See GetWindowStyleFlag() for more info.
bool | HasExtraStyle (int exFlag) const
| Returns true if the window has the given exFlag bit set in its extra styles.
bool | HasFlag (int flag) const
| Returns true if the window has the given flag bit set.
virtual void | SetExtraStyle (long exStyle)
| Sets the extra style bits for the window.
void | SetWindowStyle (long style)
| See SetWindowStyleFlag() for more info.
bool | ToggleWindowStyle (int flag)
| Turns the given flag on if it's currently turned off and vice versa.
void | MoveAfterInTabOrder (wxWindow *win)
| Moves this window in the tab navigation order after the specified win.
void | MoveBeforeInTabOrder (wxWindow *win)
| Same as MoveAfterInTabOrder() except that it inserts this window just before win instead of putting it right after it.
bool | Navigate (int flags=wxNavigationKeyEvent::IsForward)
| Performs a keyboard navigation action starting from this window.
bool | NavigateIn (int flags=wxNavigationKeyEvent::IsForward)
| Performs a keyboard navigation action inside this window.
virtual void | Lower ()
| Lowers the window to the bottom of the window hierarchy (Z-order).
virtual void | Raise ()
| Raises the window to the top of the window hierarchy (Z-order).
bool | Hide ()
| Equivalent to calling wxWindow::Show(false).
virtual bool | HideWithEffect (wxShowEffect effect, unsigned int timeout=0)
| This function hides a window, like Hide(), but using a special visual effect if possible.
bool | IsEnabled () const
| Returns true if the window is enabled, i.e. if it accepts user input, false otherwise.
bool | IsExposed (int x, int y) const
| Returns true if the given point or rectangle area has been exposed since the last repaint.
bool | IsExposed (wxPoint &pt) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
bool | IsExposed (int x, int y, int w, int h) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
bool | IsExposed (wxRect &rect) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
virtual bool | IsShown () const
| Returns true if the window is shown, false if it has been hidden.
virtual bool | IsShownOnScreen () const
| Returns true if the window is physically visible on the screen, i.e. it is shown and all its parents up to the toplevel window are shown as well.
bool | Disable ()
| Disables the window.
virtual bool | Enable (bool enable=true)
| Enable or disable the window for user input.
virtual bool | Show (bool show=true)
| Shows or hides the window.
virtual bool | ShowWithEffect (wxShowEffect effect, unsigned int timeout=0)
| This function shows a window, like Show(), but using a special visual effect if possible.
wxString | GetHelpText () const
| Gets the help text to be used as context-sensitive help for this window.
void | SetHelpText (const wxString &helpText)
| Sets the help text to be used as context-sensitive help for this window.
virtual wxString | GetHelpTextAtPoint (const wxPoint &point, wxHelpEvent::Origin origin) const
| Gets the help text to be used as context-sensitive help for this window.
wxToolTip * | GetToolTip () const
| Get the associated tooltip or NULL if none.
wxString | GetToolTipText () const
| Get the text of the associated tooltip or empty string if none.
void | SetToolTip (const wxString &tipString)
| Attach a tooltip to the window.
void | SetToolTip (wxToolTip *tip)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | UnsetToolTip ()
| Unset any existing tooltip.
int | GetPopupMenuSelectionFromUser (wxMenu &menu, const wxPoint &pos=wxDefaultPosition)
| This function shows a popup menu at the given position in this window and returns the selected id.
int | GetPopupMenuSelectionFromUser (wxMenu &menu, int x, int y)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
bool | PopupMenu (wxMenu *menu, const wxPoint &pos=wxDefaultPosition)
| Pops up the given menu at the specified coordinates, relative to this window, and returns control when the user has dismissed the menu.
bool | PopupMenu (wxMenu *menu, int x, int y)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
virtual wxValidator * | GetValidator ()
| Validator functions.
virtual void | SetValidator (const wxValidator &validator)
| Deletes the current validator (if any) and sets the window validator, having called wxValidator::Clone to create a new validator of this type.
virtual bool | TransferDataFromWindow ()
| Transfers values from child controls to data areas specified by their validators.
virtual bool | TransferDataToWindow ()
| Transfers values to child controls from data areas specified by their validators.
virtual bool | Validate ()
| Validates the current values of the child controls using their validators.
wxWindowID | GetId () const
| Returns the identifier of the window.
virtual wxLayoutDirection | GetLayoutDirection () const
| Returns the layout direction for this window, Note that `wxLayout_Default` is returned if layout direction is not supported.
virtual wxCoord | AdjustForLayoutDirection (wxCoord x, wxCoord width, wxCoord widthTotal) const
| Mirror coordinates for RTL layout if this window uses it and if the mirroring is not done automatically like Win32.
virtual wxString | GetName () const
| Returns the window's name.
wxWindowVariant | GetWindowVariant () const
| Returns the value previously passed to SetWindowVariant().
void | SetId (wxWindowID winid)
| Sets the identifier of the window.
virtual void | SetLayoutDirection (wxLayoutDirection dir)
| Sets the layout direction for this window.
virtual void | SetName (const wxString &name)
| Sets the window's name.
void | SetWindowVariant (wxWindowVariant variant)
| Chooses a different variant of the window display to use.
wxAcceleratorTable * | GetAcceleratorTable ()
| Gets the accelerator table for this window.
wxAccessible * | GetAccessible ()
| Returns the accessible object for this window, if any.
virtual void | SetAcceleratorTable (const wxAcceleratorTable &accel)
| Sets the accelerator table for this window.
void | SetAccessible (wxAccessible *accessible)
| Sets the accessible for this window.
bool | Close (bool force=false)
| This function simply generates a wxCloseEvent whose handler usually tries to close the window.
virtual bool | Destroy ()
| Destroys the window safely.
bool | IsBeingDeleted () const
| Returns true if this window is in process of being destroyed.
virtual wxDropTarget * | GetDropTarget () const
| Returns the associated drop target, which may be NULL.
virtual void | SetDropTarget (wxDropTarget *target)
| Associates a drop target with this window.
virtual void | DragAcceptFiles (bool accept)
| Enables or disables eligibility for drop file events (OnDropFiles).
wxSizer * | GetContainingSizer () const
| Returns the sizer of which this window is a member, if any, otherwise NULL.
wxSizer * | GetSizer () const
| Returns the sizer associated with the window by a previous call to SetSizer(), or NULL.
void | SetSizer (wxSizer *sizer, bool deleteOld=true)
| Sets the window to have the given layout sizer.
void | SetSizerAndFit (wxSizer *sizer, bool deleteOld=true)
| Associate the sizer with the window and set the window size and minimal size accordingly.
wxLayoutConstraints * | GetConstraints () const
| Returns a pointer to the window's layout constraints, or NULL if there are none.
void | SetConstraints (wxLayoutConstraints *constraints)
| Sets the window to have the given layout constraints.
virtual bool | Layout ()
| Lays out the children of this window using the associated sizer.
void | SetAutoLayout (bool autoLayout)
| Determines whether the Layout() function will be called automatically when the window is resized.
bool | GetAutoLayout () const
| Returns true if Layout() is called automatically when the window is resized.
void | CaptureMouse ()
| Directs all mouse input to this window.
wxCaret * | GetCaret () const
| Returns the caret() associated with the window.
const wxCursor & | GetCursor () const
| Return the cursor associated with this window.
virtual bool | HasCapture () const
| Returns true if this window has the current mouse capture.
void | ReleaseMouse ()
| Releases mouse input captured with CaptureMouse().
void | SetCaret (wxCaret *caret)
| Sets the caret() associated with the window.
virtual bool | SetCursor (const wxCursor &cursor)
| Sets the window's cursor.
virtual void | WarpPointer (int x, int y)
| Moves the pointer to the given position on the window.
virtual bool | EnableTouchEvents (int eventsMask)
| Request generation of touch events for this window.
wxHitTest | HitTest (wxCoord x, wxCoord y) const
| Return where the given point lies, exactly.
wxHitTest | HitTest (const wxPoint &pt) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
wxBorder | GetBorder (long flags) const
| Get the window border style from the given flags: this is different from simply doing flags & wxBORDER_MASK because it uses GetDefaultBorder() to translate wxBORDER_DEFAULT to something reasonable.
wxBorder | GetBorder () const
| Get border for the flags of this window.
virtual void | DoUpdateWindowUI (wxUpdateUIEvent &event)
| Does the window-specific updating after processing the update event.
virtual WXWidget | GetHandle () const
| Returns the platform-specific handle of the physical window.
virtual bool | HasMultiplePages () const
| This method should be overridden to return true if this window has multiple pages.
virtual void | InheritAttributes ()
| This function is (or should be, in case of custom controls) called during window creation to intelligently set up the window visual attributes, that is the font and the foreground and background colours.
virtual void | InitDialog ()
| Sends an `wxEVT_INIT_DIALOG` event, whose handler usually transfers data to the dialog via validators.
virtual bool | IsDoubleBuffered () const
| Returns true if the window contents is double-buffered by the system, i.e. if any drawing done on the window is really done on a temporary backing surface and transferred to the screen all at once later.
void | SetDoubleBuffered (bool on)
| Turn on or off double buffering of the window if the system supports it.
virtual bool | IsRetained () const
| Returns true if the window is retained, false otherwise.
bool | IsThisEnabled () const
| Returns true if this window is intrinsically enabled, false otherwise, i.e. if Enable() Enable(false) had been called.
virtual bool | IsTopLevel () const
| Returns true if the given window is a top-level one.
virtual void | OnInternalIdle ()
| This virtual function is normally only used internally, but sometimes an application may need it to implement functionality that should not be disabled by an application defining an OnIdle handler in a derived class.
virtual bool | SendIdleEvents (wxIdleEvent &event)
| Send idle event to window and all subwindows.
virtual bool | RegisterHotKey (int hotkeyId, int modifiers, int virtualKeyCode)
| Registers a system wide hotkey.
virtual bool | UnregisterHotKey (int hotkeyId)
| Unregisters a system wide hotkey.
virtual void | UpdateWindowUI (long flags=wxUPDATE_UI_NONE)
| This function sends one or more wxUpdateUIEvent to the window.
bool | BeginRepositioningChildren ()
| Prepare for changing positions of multiple child windows.
void | EndRepositioningChildren ()
| Fix child window positions after setting all of them at once.
void | CacheBestSize (const wxSize &size) const
| Sets the cached best size value.
virtual wxSize | ClientToWindowSize (const wxSize &size) const
| Converts client area size size to corresponding window size.
virtual wxSize | WindowToClientSize (const wxSize &size) const
| Converts window size size to corresponding client area size In other words, the returned value is what would GetClientSize() return if this window had given window size.
virtual void | Fit ()
| Sizes the window to fit its best size.
virtual void | FitInside ()
| Similar to Fit(), but sizes the interior (virtual) size of a window.
wxSize | FromDIP (const wxSize &sz) const
| Convert DPI-independent pixel values to the value in pixels appropriate for the current toolkit.
wxPoint | FromDIP (const wxPoint &pt) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
int | FromDIP (int d) const
| Convert DPI-independent distance in pixels to the value in pixels appropriate for the current toolkit.
wxSize | ToDIP (const wxSize &sz) const
| Convert pixel values of the current toolkit to DPI-independent pixel values.
wxPoint | ToDIP (const wxPoint &pt) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
int | ToDIP (int d) const
| Convert pixel values of the current toolkit to DPI-independent pixel values.
wxSize | GetBestSize () const
| This functions returns the best acceptable minimal size for the window.
int | GetBestHeight (int width) const
| Returns the best height needed by this window if it had the given width.
int | GetBestWidth (int height) const
| Returns the best width needed by this window if it had the given height.
void | GetClientSize (int *width, int *height) const
| Returns the size of the window 'client area' in pixels.
wxSize | GetClientSize () const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
virtual wxSize | GetEffectiveMinSize () const
| Merges the window's best size into the min size and returns the result.
virtual wxSize | GetMaxClientSize () const
| Returns the maximum size of window's client area.
virtual wxSize | GetMaxSize () const
| Returns the maximum size of the window.
virtual wxSize | GetMinClientSize () const
| Returns the minimum size of window's client area, an indication to the sizer layout mechanism that this is the minimum required size of its client area.
virtual wxSize | GetMinSize () const
| Returns the minimum size of the window, an indication to the sizer layout mechanism that this is the minimum required size.
int | GetMinWidth () const
| Returns the horizontal component of window minimal size.
int | GetMinHeight () const
| Returns the vertical component of window minimal size.
int | GetMaxWidth () const
| Returns the horizontal component of window maximal size.
int | GetMaxHeight () const
| Returns the vertical component of window maximal size.
void | GetSize (int *width, int *height) const
| Returns the size of the entire window in pixels, including title bar, border, scrollbars, etc.
wxSize | GetSize () const
| See the GetSize(int*,int*) overload for more info.
wxSize | GetVirtualSize () const
| This gets the virtual size of the window in pixels.
void | GetVirtualSize (int *width, int *height) const
| Like the other GetVirtualSize() overload but uses pointers instead.
virtual wxSize | GetBestVirtualSize () const
| Return the largest of ClientSize and BestSize (as determined by a sizer, interior children, or other means).
double | GetContentScaleFactor () const
| Returns the factor mapping logical pixels of this window to physical pixels.
double | GetDPIScaleFactor () const
| Returns the ratio of the DPI used by this window to the standard DPI.
virtual wxSize | GetWindowBorderSize () const
| Returns the size of the left/right and top/bottom borders of this window in x and y components of the result respectively.
virtual bool | InformFirstDirection (int direction, int size, int availableOtherDir)
| wxSizer and friends use this to give a chance to a component to recalc its min size once one of the final size components is known.
void | InvalidateBestSize ()
| Resets the cached best size value so it will be recalculated the next time it is needed.
void | PostSizeEvent ()
| Posts a size event to the window.
void | PostSizeEventToParent ()
| Posts a size event to the parent of this window.
virtual void | SendSizeEvent (int flags=0)
| This function sends a dummy size event to the window allowing it to re-layout its children positions.
void | SendSizeEventToParent (int flags=0)
| Safe wrapper for GetParent()->SendSizeEvent().
void | SetClientSize (int width, int height)
| This sets the size of the window client area in pixels.
void | SetClientSize (const wxSize &size)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | SetClientSize (const wxRect &rect)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | SetContainingSizer (wxSizer *sizer)
| Used by wxSizer internally to notify the window about being managed by the given sizer.
void | SetInitialSize (const wxSize &size=wxDefaultSize)
| A smart SetSize that will fill in default size components with the window's best size values.
virtual void | SetMaxClientSize (const wxSize &size)
| Sets the maximum client size of the window, to indicate to the sizer layout mechanism that this is the maximum possible size of its client area.
virtual void | SetMaxSize (const wxSize &size)
| Sets the maximum size of the window, to indicate to the sizer layout mechanism that this is the maximum possible size.
virtual void | SetMinClientSize (const wxSize &size)
| Sets the minimum client size of the window, to indicate to the sizer layout mechanism that this is the minimum required size of window's client area.
virtual void | SetMinSize (const wxSize &size)
| Sets the minimum size of the window, to indicate to the sizer layout mechanism that this is the minimum required size.
void | SetSize (int x, int y, int width, int height, int sizeFlags=wxSIZE_AUTO)
| Sets the size of the window in pixels.
void | SetSize (const wxRect &rect)
| Sets the size of the window in pixels.
void | SetSize (const wxSize &size)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | SetSize (int width, int height)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
virtual void | SetSizeHints (const wxSize &minSize, const wxSize &maxSize=wxDefaultSize, const wxSize &incSize=wxDefaultSize)
| Use of this function for windows which are not toplevel windows (such as wxDialog or wxFrame) is discouraged.
virtual void | SetSizeHints (int minW, int minH, int maxW=-1, int maxH=-1, int incW=-1, int incH=-1)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | SetVirtualSize (int width, int height)
| Sets the virtual size of the window in pixels.
void | SetVirtualSize (const wxSize &size)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
Public Member Functions inherited from wxEvtHandler
| wxEvtHandler ()
| Constructor.
virtual | ~wxEvtHandler ()
| Destructor.
template<typename T, typename T1, ...>
void | CallAfter (void(T::*method)(T1,...), T1 x1,...)
| Asynchronously call the given method.
template<typename T>
void | CallAfter (const T &functor)
| Asynchronously call the given functor.
bool | ProcessEventLocally (wxEvent &event)
| Try to process the event in this handler and all those chained to it.
bool | SafelyProcessEvent (wxEvent &event)
| Processes an event by calling ProcessEvent() and handles any exceptions that occur in the process.
void | ProcessPendingEvents ()
| Processes the pending events previously queued using QueueEvent() or AddPendingEvent(); you must call this function only if you are sure there are pending events for this handler, otherwise a `wxCHECK` will fail.
void | DeletePendingEvents ()
| Deletes all events queued on this event handler using QueueEvent() or AddPendingEvent().
void | Connect (int id, int lastId, wxEventType eventType, wxObjectEventFunction function, wxObject *userData=NULL, wxEvtHandler *eventSink=NULL)
| Connects the given function dynamically with the event handler, id and event type.
void | Connect (int id, wxEventType eventType, wxObjectEventFunction function, wxObject *userData=NULL, wxEvtHandler *eventSink=NULL)
| See the Connect(int, int, wxEventType, wxObjectEventFunction, wxObject*, wxEvtHandler*) overload for more info.
void | Connect (wxEventType eventType, wxObjectEventFunction function, wxObject *userData=NULL, wxEvtHandler *eventSink=NULL)
| See the Connect(int, int, wxEventType, wxObjectEventFunction, wxObject*, wxEvtHandler*) overload for more info.
bool | Disconnect (wxEventType eventType, wxObjectEventFunction function, wxObject *userData=NULL, wxEvtHandler *eventSink=NULL)
| Disconnects the given function dynamically from the event handler, using the specified parameters as search criteria and returning true if a matching function has been found and removed.
bool | Disconnect (int id=wxID_ANY, wxEventType eventType=wxEVT_NULL, wxObjectEventFunction function=NULL, wxObject *userData=NULL, wxEvtHandler *eventSink=NULL)
| See the Disconnect(wxEventType, wxObjectEventFunction, wxObject*, wxEvtHandler*) overload for more info.
bool | Disconnect (int id, int lastId, wxEventType eventType, wxObjectEventFunction function=NULL, wxObject *userData=NULL, wxEvtHandler *eventSink=NULL)
| See the Disconnect(wxEventType, wxObjectEventFunction, wxObject*, wxEvtHandler*) overload for more info.
template<typename EventTag, typename Functor>
void | Bind (const EventTag &eventType, Functor functor, int id=wxID_ANY, int lastId=wxID_ANY, wxObject *userData=NULL)
| Binds the given function, functor or method dynamically with the event.
template<typename EventTag, typename Class, typename EventArg, typename EventHandler>
void | Bind (const EventTag &eventType, void(Class::*method)(EventArg &), EventHandler *handler, int id=wxID_ANY, int lastId=wxID_ANY, wxObject *userData=NULL)
| See the Bind<>(const EventTag&, Functor, int, int, wxObject*) overload for more info.
template<typename EventTag, typename Functor>
bool | Unbind (const EventTag &eventType, Functor functor, int id=wxID_ANY, int lastId=wxID_ANY, wxObject *userData=NULL)
| Unbinds the given function, functor or method dynamically from the event handler, using the specified parameters as search criteria and returning true if a matching function has been found and removed.
template<typename EventTag, typename Class, typename EventArg, typename EventHandler>
bool | Unbind (const EventTag &eventType, void(Class::*method)(EventArg &), EventHandler *handler, int id=wxID_ANY, int lastId=wxID_ANY, wxObject *userData=NULL)
| See the Unbind<>(const EventTag&, Functor, int, int, wxObject*) overload for more info.
void * | GetClientData () const
| Returns user-supplied client data.
wxClientData * | GetClientObject () const
| Returns a pointer to the user-supplied client data object.
void | SetClientData (void *data)
| Sets user-supplied client data.
void | SetClientObject (wxClientData *data)
| Set the client data object.
bool | GetEvtHandlerEnabled () const
| Returns true if the event handler is enabled, false otherwise.
wxEvtHandler * | GetNextHandler () const
| Returns the pointer to the next handler in the chain.
wxEvtHandler * | GetPreviousHandler () const
| Returns the pointer to the previous handler in the chain.
void | SetEvtHandlerEnabled (bool enabled)
| Enables or disables the event handler.
void | Unlink ()
| Unlinks this event handler from the chain it's part of (if any); then links the "previous" event handler to the "next" one (so that the chain won't be interrupted).
bool | IsUnlinked () const
| Returns true if the next and the previous handler pointers of this event handler instance are NULL.
Public Member Functions inherited from wxObject
| wxObject ()
| Default ctor; initializes to NULL the internal reference data.
| wxObject (const wxObject &other)
| Copy ctor.
virtual | ~wxObject ()
| Destructor.
virtual wxClassInfo * | GetClassInfo () const
| This virtual function is redefined for every class that requires run-time type information, when using the wxDECLARE_CLASS macro (or similar).
wxObjectRefData * | GetRefData () const
| Returns the wxObject::m_refData pointer, i.e. the data referenced by this object.
bool | IsKindOf (const wxClassInfo *info) const
| Determines whether this class is a subclass of (or the same class as) the given class.
bool | IsSameAs (const wxObject &obj) const
| Returns true if this object has the same data pointer as obj.
void | Ref (const wxObject &clone)
| Makes this object refer to the data in clone.
void | SetRefData (wxObjectRefData *data)
| Sets the wxObject::m_refData pointer.
void | UnRef ()
| Decrements the reference count in the associated data, and if it is zero, deletes the data.
void | UnShare ()
| This is the same of AllocExclusive() but this method is public.
void | operator delete (void *buf)
| The delete operator is defined for debugging versions of the library only, when the identifier `__WXDEBUG__` is defined.
void * | operator new (size_t size, const wxString &filename=NULL, int lineNum=0)
| The new operator is defined for debugging versions of the library only, when the identifier `__WXDEBUG__` is defined.

## Protected Member Functions
virtual wxItemAttr * | OnGetItemAttr (long item) const
| This function may be overridden in the derived class for a control with `wxLC_VIRTUAL` style.
virtual wxItemAttr * | OnGetItemColumnAttr (long item, long column) const
| This function may be overridden in the derived class for a control with `wxLC_VIRTUAL` style.
virtual int | OnGetItemColumnImage (long item, long column) const
| Override this function in the derived class for a control with `wxLC_VIRTUAL` and `wxLC_REPORT` styles in order to specify the image index for the given line and column.
virtual int | OnGetItemImage (long item) const
| This function must be overridden in the derived class for a control with `wxLC_VIRTUAL` style having an "image list" (see SetImageList(); if the control doesn't have an image list, it is not necessary to override it).
virtual wxString | OnGetItemText (long item, long column) const
| This function must be overridden in the derived class for a control with `wxLC_VIRTUAL` style.
virtual bool | OnGetItemIsChecked (long item) const
| This function must be overridden in the derived class for a control with `wxLC_VIRTUAL` style that uses checkboxes.
virtual void | DoCentre (int direction)
| Centres the window.
virtual wxSize | DoGetBestSize () const
| Implementation of GetBestSize() that can be overridden.
virtual wxSize | DoGetBestClientSize () const
| Override this method to return the best size for a custom control.
virtual int | DoGetBestClientHeight (int width) const
| Override this method to implement height-for-width best size calculation.
virtual int | DoGetBestClientWidth (int height) const
| Override this method to implement width-for-height best size calculation.
virtual void | SetInitialBestSize (const wxSize &size)
| Sets the initial window size if none is given (i.e. at least one of the components of the size passed to ctor/Create() is wxDefaultCoord).
void | SendDestroyEvent ()
| Generate wxWindowDestroyEvent for this window.
virtual bool | ProcessEvent (wxEvent &event)
| This function is public in wxEvtHandler but protected in wxWindow because for wxWindows you should always call ProcessEvent() on the pointer returned by GetEventHandler() and not on the wxWindow object itself.
bool | SafelyProcessEvent (wxEvent &event)
| See ProcessEvent() for more info about why you shouldn't use this function and the reason for making this function protected in wxWindow.
virtual void | QueueEvent (wxEvent *event)
| Returns the default font and colours which are used by the control.
virtual void | AddPendingEvent (const wxEvent &event)
| Returns the default font and colours which are used by the control.
void | ProcessPendingEvents ()
| Returns the default font and colours which are used by the control.
bool | ProcessThreadEvent (const wxEvent &event)
| Returns the default font and colours which are used by the control.
virtual bool | TryBefore (wxEvent &event)
| Method called by ProcessEvent() before examining this object event tables.
virtual bool | TryAfter (wxEvent &event)
| Method called by ProcessEvent() as last resort.
Protected Member Functions inherited from wxObject
void | AllocExclusive ()
| Ensure that this object's data is not shared with any other object.
virtual wxObjectRefData * | CreateRefData () const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and returns it.
virtual wxObjectRefData * | CloneRefData (const wxObjectRefData *data) const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and initializes it copying data.

## Additional Inherited Members
Static Public Member Functions inherited from wxControl
static wxString | GetLabelText (const wxString &label)
| Returns the given label string without mnemonics ("&" characters).
static wxString | RemoveMnemonics (const wxString &str)
| Returns the given str string without mnemonics ("&" characters).
static wxString | EscapeMnemonics (const wxString &text)
| Escapes the special mnemonics characters ("&") in the given string.
static wxString | Ellipsize (const wxString &label, const wxDC &dc, wxEllipsizeMode mode, int maxWidth, int flags=wxELLIPSIZE_FLAGS_DEFAULT)
| Replaces parts of the label string with ellipsis, if needed, so that it fits into maxWidth pixels if possible.
static wxSize | FromDIP (const wxSize &sz, const wxWindow *w)
| Non window-specific DPI-independent pixels conversion functions.
static wxPoint | FromDIP (const wxPoint &pt, const wxWindow *w)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
static int | FromDIP (int d, const wxWindow *w)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
static wxSize | ToDIP (const wxSize &sz, const wxWindow *w)
| Non window-specific pixel to DPI-independent pixels conversion functions.
static wxPoint | ToDIP (const wxPoint &pt, const wxWindow *w)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
static int | ToDIP (int d, const wxWindow *w)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
static wxVisualAttributes | GetClassDefaultAttributes (wxWindowVariant variant=wxWINDOW_VARIANT_NORMAL)
| Returns the default font and colours which are used by the control.
static wxWindow * | FindFocus ()
| Finds the window or control which currently has the keyboard focus.
static wxWindow * | FindWindowById (long id, const wxWindow *parent=0)
| Find the first window with the given id.
static wxWindow * | FindWindowByLabel (const wxString &label, const wxWindow *parent=0)
| Find a window by its label.
static wxWindow * | FindWindowByName (const wxString &name, const wxWindow *parent=0)
| Find a window by its name (as given in a window constructor or Create() function call).
static wxWindow * | GetCapture ()
| Returns the currently captured window.
static wxWindowID | NewControlId (int count=1)
| Create a new ID or range of IDs that are not currently in use.
static void | UnreserveControlId (wxWindowID id, int count=1)
| Unreserve an ID or range of IDs that was reserved by NewControlId().
static void | AddFilter (wxEventFilter *filter)
| Add an event filter whose FilterEvent() method will be called for each and every event processed by wxWidgets.
static void | RemoveFilter (wxEventFilter *filter)
| Remove a filter previously installed with AddFilter().
Protected Attributes inherited from wxObject
wxObjectRefData * | m_refData
| Pointer to an object which is the object's reference-counted data.

## Constructor & Destructor Documentation

## ◆ wxListCtrl() [1/2]

wxListCtrl::wxListCtrl | ( |  | ) |

Default constructor.

## ◆ wxListCtrl() [2/2]

wxListCtrl::wxListCtrl | ( | wxWindow * | parent,
|  | wxWindowID | id,
|  | const wxPoint & | pos = wxDefaultPosition,
|  | const wxSize & | size = wxDefaultSize,
|  | long | style = wxLC_ICON,
|  | const wxValidator & | validator = wxDefaultValidator,
|  | const wxString & | name = wxListCtrlNameStr )

Constructor, creating and showing a list control.

Parameters

  parent | Parent window. Must not be NULL.
  id | Window identifier. The value wxID_ANY indicates a default value.
  pos | Window position. If wxDefaultPosition is specified then a default position is chosen.
  size | Window size. If wxDefaultSize is specified then the window is sized appropriately.
  style | Window style. See wxListCtrl.
  validator | Window validator.
  name | Window name.

See also
  Create(), wxValidator

## ◆ ~wxListCtrl()

virtual wxListCtrl::~wxListCtrl | ( |  | ) |
| virtual

Destructor, destroying the list control.

## Member Function Documentation

## ◆ AppendColumn()

long wxListCtrl::AppendColumn | ( | const wxString & | heading,
|  | wxListColumnFormat | format = wxLIST_FORMAT_LEFT,
|  | int | width = -1 )

Adds a new column to the list control in report view mode.

This is just a convenient wrapper for InsertColumn() which adds the new column after all the existing ones without having to specify its position explicitly.

Since
  2.9.4

## ◆ Arrange()

bool wxListCtrl::Arrange | ( | int | flag = wxLIST_ALIGN_DEFAULT | ) |

Arranges the items in icon or small icon view.

This only has effect on Win32. flag is one of:

- wxLIST_ALIGN_DEFAULT: Default alignment.
- wxLIST_ALIGN_LEFT: Align to the left side of the control.
- wxLIST_ALIGN_TOP: Align to the top side of the control.
- wxLIST_ALIGN_SNAP_TO_GRID: Snap to grid.

## ◆ AssignImageList()

void wxListCtrl::AssignImageList | ( | wxImageList * | imageList,
|  | int | which )

Sets the image list associated with the control and takes ownership of it (i.e.

the control will, unlike when using SetImageList(), delete the list when destroyed). which is one of `wxIMAGE_LIST_NORMAL`, `wxIMAGE_LIST_SMALL`, `wxIMAGE_LIST_STATE` (the last is unimplemented).

See also
  SetImageList()

## ◆ CheckItem()

void wxListCtrl::CheckItem | ( | long | item,
|  | bool | check )

Check or uncheck a wxListItem in a control using checkboxes.

This method only works if checkboxes support had been successfully enabled using EnableCheckBoxes().

Parameters

  item | Item (zero-based) index.
  check | If true, check the item, otherwise uncheck.

Since
  3.1.0

## ◆ ClearAll()

void wxListCtrl::ClearAll | ( |  | ) |

Deletes all items and all columns.

Note
  This sends an event of type `wxEVT_LIST_DELETE_ALL_ITEMS` under all platforms.

## ◆ Create()

bool wxListCtrl::Create | ( | wxWindow * | parent,
|  | wxWindowID | id,
|  | const wxPoint & | pos = wxDefaultPosition,
|  | const wxSize & | size = wxDefaultSize,
|  | long | style = wxLC_ICON,
|  | const wxValidator & | validator = wxDefaultValidator,
|  | const wxString & | name = wxListCtrlNameStr )

Creates the list control.

See wxListCtrl() for further details.

## ◆ DeleteAllColumns()

bool wxListCtrl::DeleteAllColumns | ( |  | ) |

Delete all columns in the list control.

Returns
  true if all columns were successfully deleted, false otherwise.

## ◆ DeleteAllItems()

bool wxListCtrl::DeleteAllItems | ( |  | ) |

Deletes all items in the list control.

This function does not send the `wxEVT_LIST_DELETE_ITEM` event because deleting many items from the control would be too slow then (unlike wxListCtrl::DeleteItem) but it does send the special `wxEVT_LIST_DELETE_ALL_ITEMS` event if the control was not empty. If it was already empty, nothing is done and no event is sent.

Returns
  true if the items were successfully deleted or if the control was already empty, false if an error occurred while deleting the items.

## ◆ DeleteColumn()

bool wxListCtrl::DeleteColumn | ( | int | col | ) |

Deletes a column.

## ◆ DeleteItem()

bool wxListCtrl::DeleteItem | ( | long | item | ) |

Deletes the specified item.

This function sends the `wxEVT_LIST_DELETE_ITEM` event for the item being deleted.

See also
  DeleteAllItems()

## ◆ EditLabel()

wxTextCtrl * wxListCtrl::EditLabel | ( | long | item,
|  | wxClassInfo * | textControlClass = wxCLASSINFO(wxTextCtrl) )

Starts editing the label of the given item.

This function generates a `EVT_LIST_BEGIN_LABEL_EDIT` event which can be vetoed so that no text control will appear for in-place editing.

If the user changed the label (i.e. s/he does not press ESC or leave the text control without changes, a `EVT_LIST_END_LABEL_EDIT` event will be sent which can be vetoed as well.

## ◆ EnableAlternateRowColours()

void wxListCtrl::EnableAlternateRowColours | ( | bool | enable = true | ) |

Enable alternating row background colours (also called zebra striping).

This method can only be called for the control in virtual report mode, i.e. having wxLC_REPORT and wxLC_VIRTUAL styles.

When enabling alternating colours, the appropriate colour for the even rows is chosen automatically depending on the default foreground and background colours which are used for the odd rows.

Parameters

  enable | If true, enable alternating row background colours, i.e. different colours for the odd and even rows. If false, disable this feature and use the same background colour for all rows.

Since
  2.9.5

See also
  SetAlternateRowColour()

## ◆ EnableBellOnNoMatch()

void wxListCtrl::EnableBellOnNoMatch | ( | bool | on = true | ) |

Enable or disable a beep if there is no match for the currently entered text when searching for the item from keyboard.

The default is to not beep in this case except in wxMSW where the beep is always generated by the native control and cannot be disabled, i.e. calls to this function do nothing there.

Since
  2.9.5

## ◆ EnableCheckBoxes()

bool wxListCtrl::EnableCheckBoxes | ( | bool | enable = true | ) |

Enable or disable checkboxes for list items.

Parameters

  enable | If true, enable checkboxes, otherwise disable checkboxes.

Returns
  true if checkboxes are supported, false otherwise.

In a list control with wxLC_VIRTUAL style you have to keep track of the checkbox state. When a checkbox is clicked (EVT_LIST_ITEM_CHECKED or EVT_LIST_ITEM_UNCHECKED) you have to update the state and refresh the item yourself.

See also
  OnGetItemIsChecked() RefreshItem()

Since
  3.1.0

## ◆ EndEditLabel()

bool wxListCtrl::EndEditLabel | ( | bool | cancel | ) |

Finish editing the label.

This method allows one to programmatically end editing a list control item in place. Usually it will only be called when editing is in progress, i.e. if GetEditControl() returns non-NULL. In particular, do not call it from EVT_LIST_BEGIN_LABEL_EDIT handler as the edit control is not yet fully created by then, just veto the event in this handler instead to prevent the editing from even starting.

Notice that calling this method will result in EVT_LIST_END_LABEL_EDIT event being generated.

Currently only implemented in wxMSW.

Parameters

  cancel | If true, discard the changes made by user, as if `Escape` key was pressed. Otherwise, accept the changes as if `Return` was pressed.

Returns
  true if item editing was finished or false if no item as being edited.

## ◆ EnsureVisible()

bool wxListCtrl::EnsureVisible | ( | long | item | ) |

Ensures this item is visible.

## ◆ ExtendRulesAndAlternateColour()

void wxListCtrl::ExtendRulesAndAlternateColour | ( | bool | extend = true | ) |

Extend rules and alternate rows background to the entire client area.

Bu default, the rules (when enabled with wxLC_HRULES and wxLC_VRULES) and alternate row background (when EnableAlternateRowColours() was called) are only shown in the part of the control occupied by the items, which can be smaller than the entire window if there are few items in the control.

Calling this function extends the display of the rules and alternate background rows to the entire client area.

Similarly to EnableAlternateRowColours(), this method can only be used with controls having wxLC_REPORT and wxLC_VIRTUAL styles.

Note that this method is currently not implemented in the native MSW version and does nothing there.

Parameters

  extend | if true, draws horizontal rules and vertical rules on empty rows and uses the colour parameter to paint the background of alternate rows when those rows are blank, empty, with no data.

Since
  3.1.5

## ◆ FindItem() [1/3]

long wxListCtrl::FindItem | ( | long | start,
|  | const wxPoint & | pt,
|  | int | direction )

Find an item nearest this position in the specified direction, starting from start or the beginning if start is -1.

wxPerl Note: In wxPerl this method is implemented as FindItemAtPos(start, pt, direction).

Returns
  The next matching item if any or `-1` (wxNOT_FOUND) otherwise.

## ◆ FindItem() [2/3]

long wxListCtrl::FindItem | ( | long | start,
|  | const wxString & | str,
|  | bool | partial = false )

Find an item whose label matches this string, starting from start or the beginning if start is `-1`.

The string comparison is case insensitive.

If partial is true then this method will look for items which begin with str.

Returns
  The next matching item if any or `-1` (wxNOT_FOUND) otherwise.

## ◆ FindItem() [3/3]

long wxListCtrl::FindItem | ( | long | start,
|  | wxUIntPtr | data )

Find an item whose data matches this data, starting from start or the beginning if 'start' is `-1`.

wxPerl Note: In wxPerl this method is implemented as FindItemData(start, data).

Returns
  The next matching item if any or `-1` (wxNOT_FOUND) otherwise.

## ◆ GetAlternateRowColour()

wxColour wxListCtrl::GetAlternateRowColour | ( |  | ) | const

Get the alternative row background colour.

Since
  3.1.0

See also
  SetAlternateRowColour()

## ◆ GetColumn()

bool wxListCtrl::GetColumn | ( | int | col,
|  | wxListItem & | item ) const

Gets information about this column.

See SetItem() for more information.

wxPerl Note: In wxPerl this method takes only the col parameter and returns a `Wx::ListItem` (or `undef`).

## ◆ GetColumnCount()

int wxListCtrl::GetColumnCount | ( |  | ) | const

Returns the number of columns.

## ◆ GetColumnIndexFromOrder()

int wxListCtrl::GetColumnIndexFromOrder | ( | int | pos | ) | const

Gets the column index from its position in visual order.

After calling SetColumnsOrder(), the index returned by this function corresponds to the value of the element number pos in the array returned by GetColumnsOrder().

Please see SetColumnsOrder() documentation for an example and additional remarks about the columns ordering.

See also
  GetColumnOrder()

## ◆ GetColumnOrder()

int wxListCtrl::GetColumnOrder | ( | int | col | ) | const

Gets the column visual order position.

This function returns the index of the column which appears at the given visual position, e.g. calling it with col equal to 0 returns the index of the first shown column.

Please see SetColumnsOrder() documentation for an example and additional remarks about the columns ordering.

See also
  GetColumnsOrder(), GetColumnIndexFromOrder()

## ◆ GetColumnsOrder()

wxArrayInt wxListCtrl::GetColumnsOrder | ( |  | ) | const

Returns the array containing the orders of all columns.

On error, an empty array is returned.

Please see SetColumnsOrder() documentation for an example and additional remarks about the columns ordering.

See also
  GetColumnOrder(), GetColumnIndexFromOrder()

## ◆ GetColumnWidth()

int wxListCtrl::GetColumnWidth | ( | int | col | ) | const

Gets the column width (report view only).

## ◆ GetCountPerPage()

int wxListCtrl::GetCountPerPage | ( |  | ) | const

Gets the number of items that can fit vertically in the visible area of the list control (list or report view) or the total number of items in the list control (icon or small icon view).

## ◆ GetEditControl()

wxTextCtrl * wxListCtrl::GetEditControl | ( |  | ) | const

Returns the edit control being currently used to edit a label.

Returns NULL if no label is being edited.

Note
  It is currently only implemented for wxMSW and the generic version, not for the native macOS version.

## ◆ GetImageList()

wxImageList * wxListCtrl::GetImageList | ( | int | which | ) | const

Returns the specified image list.

which may be one of:

- wxIMAGE_LIST_NORMAL: The normal (large icon) image list.
- wxIMAGE_LIST_SMALL: The small icon image list.
- wxIMAGE_LIST_STATE: The user-defined state image list (unimplemented).

## ◆ GetItem()

bool wxListCtrl::GetItem | ( | wxListItem & | info | ) | const

Gets information about the item.

See SetItem() for more information.

You must call info.SetId() to set the ID of item you're interested in before calling this method, and info.SetMask() with the flags indicating what fields you need to retrieve from info.

wxPerl Note: In wxPerl this method takes as parameter the ID of the item and (optionally) the column, and returns a Wx::ListItem object.

## ◆ GetItemBackgroundColour()

wxColour wxListCtrl::GetItemBackgroundColour | ( | long | item | ) | const

Returns the colour for this item.

If the item has no specific colour, returns an invalid colour (and not the default background control of the control itself).

See also
  GetItemTextColour()

## ◆ GetItemCount()

int wxListCtrl::GetItemCount | ( |  | ) | const

Returns the number of items in the list control.

## ◆ GetItemData()

wxUIntPtr wxListCtrl::GetItemData | ( | long | item | ) | const

Gets the application-defined data associated with this item.

## ◆ GetItemFont()

wxFont wxListCtrl::GetItemFont | ( | long | item | ) | const

Returns the item's font.

## ◆ GetItemPosition()

bool wxListCtrl::GetItemPosition | ( | long | item,
|  | wxPoint & | pos ) const

Returns the position of the item, in icon or small icon view.

wxPerl Note: In wxPerl this method takes only the item parameter and returns a `Wx::Point` (or `undef`).

## ◆ GetItemRect()

bool wxListCtrl::GetItemRect | ( | long | item,
|  | wxRect & | rect,
|  | int | code = wxLIST_RECT_BOUNDS ) const

Returns the rectangle representing the item's size and position, in physical coordinates.

code is one of wxLIST_RECT_BOUNDS, wxLIST_RECT_ICON, wxLIST_RECT_LABEL.

wxPerl Note: In wxPerl this method takes only the item and code parameters and returns a `Wx::Rect` (or `undef`).

## ◆ GetItemSpacing()

wxSize wxListCtrl::GetItemSpacing | ( |  | ) | const

Retrieves the spacing between icons in pixels: horizontal spacing is returned as `x` component of the wxSize object and the vertical spacing as its `y` component.

## ◆ GetItemState()

int wxListCtrl::GetItemState | ( | long | item,
|  | long | stateMask ) const

Gets the item state.

For a list of state flags, see SetItem(). The stateMask indicates which state flags are of interest.

## ◆ GetItemText()

wxString wxListCtrl::GetItemText | ( | long | item,
|  | int | col = 0 ) const

Gets the item text for this item.

Parameters

  item | Item (zero-based) index.
  col | Item column (zero-based) index. Column 0 is the default. This parameter is new in wxWidgets 2.9.1.

## ◆ GetItemTextColour()

wxColour wxListCtrl::GetItemTextColour | ( | long | item | ) | const

Returns the colour for this item.

If the item has no specific colour, returns an invalid colour (and not the default foreground control of the control itself as this wouldn't allow distinguishing between items having the same colour as the current control foreground and items with default colour which, hence, have always the same colour as the control).

## ◆ GetNextItem()

long wxListCtrl::GetNextItem | ( | long | item,
|  | int | geometry = wxLIST_NEXT_ALL,
|  | int | state = wxLIST_STATE_DONTCARE ) const

Searches for an item with the given geometry or state, starting from item but excluding the item itself.

If item is -1, the first item that matches the specified flags will be returned. Returns the first item with given state following item or -1 if no such item found. This function may be used to find all selected items in the control like this:

long item = -1;
for ( ;; )
{
item = listctrl->GetNextItem(item,
wxLIST_NEXT_ALL,
wxLIST_STATE_SELECTED);
if ( item == -1 )
break;
// this item is selected - do whatever is needed with it
wxLogMessage("Item %ld is selected.", item);
}
wxLIST_NEXT_ALL
@ wxLIST_NEXT_ALL
Definition listctrl.h:68
wxLIST_STATE_SELECTED
#define wxLIST_STATE_SELECTED
Definition listctrl.h:46
wxLogMessage
void wxLogMessage(const char *formatString,...)
For all normal, informational messages.

geometry can be one of:

- wxLIST_NEXT_ABOVE: Searches for an item above the specified item.
- wxLIST_NEXT_ALL: Searches for subsequent item by index.
- wxLIST_NEXT_BELOW: Searches for an item below the specified item.
- wxLIST_NEXT_LEFT: Searches for an item to the left of the specified item.
- wxLIST_NEXT_RIGHT: Searches for an item to the right of the specified item.

Note
  this parameter is only supported by wxMSW currently and ignored on other platforms.

state can be a bitlist of the following:

- wxLIST_STATE_DONTCARE: Don't care what the state is.
- wxLIST_STATE_DROPHILITED: The item indicates it is a drop target.
- wxLIST_STATE_FOCUSED: The item has the focus.
- wxLIST_STATE_SELECTED: The item is selected.
- wxLIST_STATE_CUT: The item is selected as part of a cut and paste operation.

## ◆ GetSelectedItemCount()

int wxListCtrl::GetSelectedItemCount | ( |  | ) | const

Returns the number of selected items in the list control.

## ◆ GetSubItemRect()

bool wxListCtrl::GetSubItemRect | ( | long | item,
|  | long | subItem,
|  | wxRect & | rect,
|  | int | code = wxLIST_RECT_BOUNDS ) const

Returns the rectangle representing the size and position, in physical coordinates, of the given subitem, i.e.

the part of the row item in the column subItem.

This method is only meaningful when the wxListCtrl is in the report mode. If subItem parameter is equal to the special value `wxLIST_GETSUBITEMRECT_WHOLEITEM` the return value is the same as for GetItemRect().

code can be one of `wxLIST_RECT_BOUNDS`, `wxLIST_RECT_ICON` or `wxLIST_RECT_LABEL`.

Note that using `wxLIST_RECT_ICON` with any sub-item but the first one isn't very useful as only the first sub-item can have an icon in wxListCtrl. In this case, i.e. for `subItem` > 0, this function simply returns an empty rectangle in rect.

Since
  2.7.0

## ◆ GetTextColour()

wxColour wxListCtrl::GetTextColour | ( |  | ) | const

Gets the text colour of the list control.

## ◆ GetTopItem()

long wxListCtrl::GetTopItem | ( |  | ) | const

Gets the index of the topmost visible item when in list or report view.

## ◆ GetViewRect()

wxRect wxListCtrl::GetViewRect | ( |  | ) | const

Returns the rectangle taken by all items in the control.

In other words, if the controls client size were equal to the size of this rectangle, no scrollbars would be needed and no free space would be left.

Note that this function only works in the icon and small icon views, not in list or report views (this is a limitation of the native Win32 control).

## ◆ HasCheckBoxes()

bool wxListCtrl::HasCheckBoxes | ( |  | ) | const

Returns true if checkboxes are enabled for list items.

See also
  EnableCheckBoxes()

Since
  3.1.0

## ◆ HitTest()

long wxListCtrl::HitTest | ( | const wxPoint & | point,
|  | int & | flags,
|  | long * | ptrSubItem = NULL ) const

Determines which item (if any) is at the specified point, giving details in flags.

Returns index of the item or `wxNOT_FOUND` if no item is at the specified point.

flags will be a combination of the following flags:

- wxLIST_HITTEST_ABOVE: Above the control's client area.
- wxLIST_HITTEST_BELOW: Below the control's client area.
- wxLIST_HITTEST_TOLEFT: To the left of the control's client area.
- wxLIST_HITTEST_TORIGHT: To the right of the control's client area.
- wxLIST_HITTEST_NOWHERE: Inside the control's client area but not over an item.
- wxLIST_HITTEST_ONITEMICON: Over an item's icon.
- wxLIST_HITTEST_ONITEMLABEL: Over an item's text.
- wxLIST_HITTEST_ONITEMSTATEICON: Over the checkbox of an item.
- wxLIST_HITTEST_ONITEM: Combination of `wxLIST_HITTEST_ONITEMICON`, `wxLIST_HITTEST_ONITEMLABEL`, `wxLIST_HITTEST_ONITEMSTATEICON`.

If ptrSubItem is not NULL and the wxListCtrl is in the report mode the subitem (or column) number will also be provided. This feature is only available in version 2.7.0 or higher and is currently only implemented under wxMSW and requires at least comctl32.dll of version 4.70 on the host system or the value stored in ptrSubItem will be always -1. To compile this feature into wxWidgets library you need to have access to commctrl.h of version 4.70 that is provided by Microsoft.

wxPerl Note: In wxPerl this method only takes the point parameter and returns a 2-element list (item, flags).

## ◆ InReportView()

bool wxListCtrl::InReportView | ( |  | ) | const

Returns true if the control is currently using wxLC_REPORT style.

## ◆ InsertColumn() [1/2]

long wxListCtrl::InsertColumn | ( | long | col,
|  | const wxListItem & | info )

For report view mode (only), inserts a column.

For more details, see SetItem(). Also see InsertColumn(long, const wxString&, int, int) overload for a usually more convenient alternative to this method and the description of how the item width is interpreted by this method.

## ◆ InsertColumn() [2/2]

long wxListCtrl::InsertColumn | ( | long | col,
|  | const wxString & | heading,
|  | int | format = wxLIST_FORMAT_LEFT,
|  | int | width = wxLIST_AUTOSIZE )

For report view mode (only), inserts a column.

Insert a new column in the list control in report view mode at the given position specifying its most common attributes.

Notice that to set the image for the column you need to use InsertColumn(long, const wxListItem&) overload and specify wxLIST_MASK_IMAGE in the item mask.

Parameters

  col | The index where the column should be inserted. Valid indices are from 0 up to GetColumnCount() inclusive and the latter can be used to append the new column after the last existing one.
  heading | The string specifying the column heading.
  format | The flags specifying the control heading text alignment.
  width | If positive, the width of the column in pixels. Otherwise it can be `wxLIST_AUTOSIZE` to choose the default size for the column or `wxLIST_AUTOSIZE_USEHEADER` to fit the column width to heading or to extend to fill all the remaining space for the last column. Notice that in case of `wxLIST_AUTOSIZE` fixed width is used as there are no items in this column to use for determining its best size yet. If you want to fit the column to its contents, use SetColumnWidth() after adding the items with values in this column.

Returns
  The index of the inserted column or -1 if adding it failed.

## ◆ InsertItem() [1/4]

long wxListCtrl::InsertItem | ( | long | index,
|  | const wxString & | label )

Insert a string item.

Parameters

  index | Index of the new item, supplied by the application
  label | String label

wxPerl Note: In wxPerl this method is implemented as InsertStringItem(index, label).

## ◆ InsertItem() [2/4]

long wxListCtrl::InsertItem | ( | long | index,
|  | const wxString & | label,
|  | int | imageIndex )

Insert an image/string item.

Parameters

  index | Index of the new item, supplied by the application
  label | String label
  imageIndex | Index into the image list associated with this control and view style

wxPerl Note: In wxPerl this method is implemented as InsertImageStringItem(index, label, imageIndex).

## ◆ InsertItem() [3/4]

long wxListCtrl::InsertItem | ( | long | index,
|  | int | imageIndex )

Insert an image item.

Parameters

  index | Index of the new item, supplied by the application
  imageIndex | Index into the image list associated with this control and view style

wxPerl Note: In wxPerl this method is implemented as InsertImageItem(index, imageIndex).

## ◆ InsertItem() [4/4]

long wxListCtrl::InsertItem | ( | wxListItem & | info | ) |

Inserts an item, returning the index of the new item if successful, -1 otherwise.

Parameters

  info | wxListItem object

## ◆ IsEmpty()

bool wxListCtrl::IsEmpty | ( |  | ) | const

Returns true if the control doesn't currently contain any items.

Note that the control with some columns is still considered to be empty if it has no rows.

Since
  3.1.3

## ◆ IsItemChecked()

bool wxListCtrl::IsItemChecked | ( | long | item | ) | const

Return true if the checkbox for the given wxListItem is checked.

Always returns false if checkboxes support hadn't been enabled.

Parameters

  item | Item (zero-based) index.

Since
  3.1.0

## ◆ IsVirtual()

bool wxListCtrl::IsVirtual | ( |  | ) | const

Returns true if the control is currently in virtual report view.

## ◆ IsVisible()

bool wxListCtrl::IsVisible | ( | long | item | ) | const

Check if the item is visible.

An item is considered visible if at least one pixel of it is present on the screen.

Since
  3.1.3

## ◆ OnGetItemAttr()

virtual wxItemAttr * wxListCtrl::OnGetItemAttr | ( | long | item | ) | const
| protectedvirtual

This function may be overridden in the derived class for a control with `wxLC_VIRTUAL` style.

It should return the attribute for the specified `item` or NULL to use the default appearance parameters.

wxListCtrl will not delete the pointer or keep a reference of it. You can return the same wxItemAttr pointer for every OnGetItemAttr() call.

The base class version always returns NULL.

See also
  OnGetItemImage(), OnGetItemColumnImage(), OnGetItemText(), OnGetItemColumnAttr(), OnGetItemIsChecked()

## ◆ OnGetItemColumnAttr()

virtual wxItemAttr * wxListCtrl::OnGetItemColumnAttr | ( | long | item,
|  | long | column ) const
| protectedvirtual

This function may be overridden in the derived class for a control with `wxLC_VIRTUAL` style.

It should return the attribute for the for the specified item and column or NULL to use the default appearance parameters.

The base class version returns `OnGetItemAttr(item)`.

Note
  Currently this function is only called under wxMSW, the other ports only support OnGetItemAttr()

See also
  OnGetItemAttr(), OnGetItemText(), OnGetItemImage(), OnGetItemColumnImage(),

## ◆ OnGetItemColumnImage()

virtual int wxListCtrl::OnGetItemColumnImage | ( | long | item,
|  | long | column ) const
| protectedvirtual

Override this function in the derived class for a control with `wxLC_VIRTUAL` and `wxLC_REPORT` styles in order to specify the image index for the given line and column.

The base class version always calls OnGetItemImage() for the first column, else it returns -1.

See also
  OnGetItemText(), OnGetItemImage(), OnGetItemAttr(), OnGetItemColumnAttr()

## ◆ OnGetItemImage()

virtual int wxListCtrl::OnGetItemImage | ( | long | item | ) | const
| protectedvirtual

This function must be overridden in the derived class for a control with `wxLC_VIRTUAL` style having an "image list" (see SetImageList(); if the control doesn't have an image list, it is not necessary to override it).

It should return the index of the items image in the controls image list or -1 for no image.

In a control with `wxLC_REPORT` style, OnGetItemImage() only gets called for the first column of each line.

The base class version always returns -1.

See also
  OnGetItemText(), OnGetItemColumnImage(), OnGetItemAttr()

## ◆ OnGetItemIsChecked()

virtual bool wxListCtrl::OnGetItemIsChecked | ( | long | item | ) | const
| protectedvirtual

This function must be overridden in the derived class for a control with `wxLC_VIRTUAL` style that uses checkboxes.

It should return whether the checkbox of the specified `item` is checked.

See also
  EnableCheckBoxes(), OnGetItemText()

Since
  3.1.2

## ◆ OnGetItemText()

virtual wxString wxListCtrl::OnGetItemText | ( | long | item,
|  | long | column ) const
| protectedvirtual

This function must be overridden in the derived class for a control with `wxLC_VIRTUAL` style.

It should return the string containing the text of the given column for the specified `item`.

See also
  SetItemCount(), OnGetItemImage(), OnGetItemColumnImage(), OnGetItemAttr()

## ◆ RefreshItem()

void wxListCtrl::RefreshItem | ( | long | item | ) |

Redraws the given item.

This is only useful for the virtual list controls as without calling this function the displayed value of the item doesn't change even when the underlying data does change.

See also
  RefreshItems()

## ◆ RefreshItems()

void wxListCtrl::RefreshItems | ( | long | itemFrom,
|  | long | itemTo )

Redraws the items between itemFrom and itemTo.

The starting item must be less than or equal to the ending one.

Just as RefreshItem() this is only useful for virtual list controls.

## ◆ ScrollList()

bool wxListCtrl::ScrollList | ( | int | dx,
|  | int | dy )

Scrolls the list control.

If in icon, small icon or report view mode, dx specifies the number of pixels to scroll. If in list view mode, dx specifies the number of columns to scroll. dy always specifies the number of pixels to scroll vertically.

Note
  This method is currently only implemented in the Windows version.

## ◆ SetAlternateRowColour()

void wxListCtrl::SetAlternateRowColour | ( | const wxColour & | colour | ) |

Set the alternative row background colour to a specific colour.

It is recommended to call EnableAlternateRowColours() instead of using these methods as native implementations of this control might support alternating row colours but not setting the exact colour to be used for them.

As EnableAlternateRowColours(), this method can only be used with controls having wxLC_REPORT and wxLC_VIRTUAL styles.

Parameters

  colour | A valid alternative row background colour to enable alternating rows or invalid colour to disable them and use the same colour for all rows.

Since
  2.9.5

## ◆ SetBackgroundColour()

virtual bool wxListCtrl::SetBackgroundColour | ( | const wxColour & | col | ) |
| virtual

Sets the background colour.

Note that the wxWindow::GetBackgroundColour() function of wxWindow base class can be used to retrieve the current background colour.

Reimplemented from wxWindow.

## ◆ SetColumn()

bool wxListCtrl::SetColumn | ( | int | col,
|  | wxListItem & | item )

Sets information about this column.

See SetItem() for more information.

## ◆ SetColumnsOrder()

bool wxListCtrl::SetColumnsOrder | ( | const wxArrayInt & | orders | ) |

Changes the order in which the columns are shown.

By default, the columns of a list control appear on the screen in order of their indices, i.e. the column 0 appears first, the column 1 next and so on. However by using this function it is possible to arbitrarily reorder the columns visual order and the user can also rearrange the columns interactively by dragging them. In this case, the index of the column is not the same as its order and the functions GetColumnOrder() and GetColumnIndexFromOrder() should be used to translate between them. Notice that all the other functions still work with the column indices, i.e. the visual positioning of the columns on screen doesn't affect the code setting or getting their values for example.

The orders array must have the same number elements as the number of columns and contain each position exactly once. Its n-th element contains the index of the column to be shown in n-th position, so for a control with three columns passing an array with elements 2, 0 and 1 results in the third column being displayed first, the first one next and the second one last.

Example of using it:

wxListCtrl *list = new wxListCtrl(...);
for ( int i = 0; i < 3; i++ )
list->InsertColumn(i, wxString::Format("Column %d", i));
wxArrayInt order(3);
order[0] = 2;
order[1] = 0;
order[2] = 1;
list->SetColumnsOrder(order);
// now list->GetColumnsOrder() will return order and
// list->GetColumnIndexFromOrder(n) will return order[n] and
// list->GetColumnOrder() will return 1, 2 and 0 for the column 0,
// 1 and 2 respectively
wxListCtrl::SetColumnsOrder
bool SetColumnsOrder(const wxArrayInt &orders)
Changes the order in which the columns are shown.
wxListCtrl::wxListCtrl
wxListCtrl()
Default constructor.
wxListCtrl::InsertColumn
long InsertColumn(long col, const wxListItem &info)
For report view mode (only), inserts a column.
wxString::Format
static wxString Format(const wxString &format,...)
This static function returns the string containing the result of calling Printf() with the passed par...
wxArrayInt
wxArray< int > wxArrayInt
Predefined specialization of wxArray<T> for standard types.
Definition dynarray.h:810

Please notice that this function makes sense for report view only and currently is only implemented in wxMSW port. To avoid explicit tests for `__WXMSW__` in your code, please use `wxHAS_LISTCTRL_COLUMN_ORDER` as this will allow it to start working under the other platforms when support for the column reordering is added there.

See also
  GetColumnsOrder()

## ◆ SetColumnWidth()

bool wxListCtrl::SetColumnWidth | ( | int | col,
|  | int | width )

Sets the column width.

width can be a width in pixels or `wxLIST_AUTOSIZE` (-1) or `wxLIST_AUTOSIZE_USEHEADER` (-2).

`wxLIST_AUTOSIZE` will resize the column to the length of its longest item.

`wxLIST_AUTOSIZE_USEHEADER` will resize the column to the length of the header (Win32) or 80 pixels (other platforms).

In small or normal icon view, col must be -1, and the column width is set for all columns.

## ◆ SetHeaderAttr()

bool wxListCtrl::SetHeaderAttr | ( | const wxItemAttr & | attr | ) |

Change the font and the colours used for the list control header.

This method can be used to change the appearance of the header shown by the control in report mode (unless `wxLC_NO_HEADER` style is used).

Currently it is implemented only for wxMSW and does nothing in the other ports.

Parameters

  attr | The object containing the font and text and background colours to use. It may be default, i.e. not specify any custom font nor colours, to reset any previously set custom attribute.

Returns
  true if the attributes have been updated or false if this is not supported by the current platform.

Since
  3.1.1

## ◆ SetImageList()

void wxListCtrl::SetImageList | ( | wxImageList * | imageList,
|  | int | which )

Sets the image list associated with the control.

which is one of `wxIMAGE_LIST_NORMAL`, `wxIMAGE_LIST_SMALL`, `wxIMAGE_LIST_STATE` (the last is unimplemented).

This method does not take ownership of the image list, you have to delete it yourself.

See also
  AssignImageList()

## ◆ SetItem() [1/2]

bool wxListCtrl::SetItem | ( | long | index,
|  | int | column,
|  | const wxString & | label,
|  | int | imageId = -1 )

Sets an item string field at a particular column.

Returns
  true if the item was successfully updated or false if the update failed for some reason (e.g. an invalid item index).

## ◆ SetItem() [2/2]

bool wxListCtrl::SetItem | ( | wxListItem & | info | ) |

Sets the data of an item.

Using the wxListItem's mask and state mask, you can change only selected attributes of a wxListCtrl item.

Returns
  true if the item was successfully updated or false if the update failed for some reason (e.g. an invalid item index).

## ◆ SetItemBackgroundColour()

void wxListCtrl::SetItemBackgroundColour | ( | long | item,
|  | const wxColour & | col )

Sets the background colour for this item.

This function only works in report view mode. The colour can be retrieved using GetItemBackgroundColour().

## ◆ SetItemColumnImage()

bool wxListCtrl::SetItemColumnImage | ( | long | item,
|  | long | column,
|  | int | image )

Sets the image associated with the item.

In report view, you can specify the column. The image is an index into the image list associated with the list control.

## ◆ SetItemCount()

void wxListCtrl::SetItemCount | ( | long | count | ) |

This method can only be used with virtual list controls.

It is used to indicate to the control the number of items it contains. After calling it, the main program should be ready to handle calls to various item callbacks (such as wxListCtrl::OnGetItemText) for all items in the range from 0 to count.

Notice that the control is not necessarily redrawn after this call as it may be undesirable if an item which is not visible on the screen anyhow was added to or removed from a control displaying many items, if you do need to refresh the display you can just call Refresh() manually.

## ◆ SetItemData()

bool wxListCtrl::SetItemData | ( | long | item,
|  | long | data )

Associates application-defined data with this item.

Notice that this function cannot be used to associate pointers with the control items, use SetItemPtrData() instead.

## ◆ SetItemFont()

void wxListCtrl::SetItemFont | ( | long | item,
|  | const wxFont & | font )

Sets the item's font.

## ◆ SetItemImage()

bool wxListCtrl::SetItemImage | ( | long | item,
|  | int | image,
|  | int | selImage = -1 )

Sets the unselected and selected images associated with the item.

The images are indices into the image list associated with the list control.

## ◆ SetItemPosition()

bool wxListCtrl::SetItemPosition | ( | long | item,
|  | const wxPoint & | pos )

Sets the position of the item, in icon or small icon view.

Windows only.

## ◆ SetItemPtrData()

bool wxListCtrl::SetItemPtrData | ( | long | item,
|  | wxUIntPtr | data )

Associates application-defined data with this item.

The data parameter may be either an integer or a pointer cast to the `wxUIntPtr` type which is guaranteed to be large enough to be able to contain all integer types and pointers.

Since
  2.8.4

## ◆ SetItemState()

bool wxListCtrl::SetItemState | ( | long | item,
|  | long | state,
|  | long | stateMask )

Sets the item state.

The stateMask is a combination of `wxLIST_STATE_XXX` constants described in wxListItem documentation. For each of the bits specified in stateMask, the corresponding state is set or cleared depending on whether state argument contains the same bit or not.

So to select an item you can use

list->SetItemState(item, wxLIST_STATE_SELECTED, wxLIST_STATE_SELECTED);

while to deselect it you should use

list->SetItemState(item, 0, wxLIST_STATE_SELECTED);

Consider using wxListView if possible to avoid dealing with this error-prone and confusing method.

Also notice that contrary to the usual rule that only user actions generate events, this method does generate wxEVT_LIST_ITEM_SELECTED event when it is used to select an item.

## ◆ SetItemText()

void wxListCtrl::SetItemText | ( | long | item,
|  | const wxString & | text )

Sets the item text for this item.

## ◆ SetItemTextColour()

void wxListCtrl::SetItemTextColour | ( | long | item,
|  | const wxColour & | col )

Sets the colour for this item.

This function only works in report view. The colour can be retrieved using GetItemTextColour().

## ◆ SetSingleStyle()

void wxListCtrl::SetSingleStyle | ( | long | style,
|  | bool | add = true )

Adds or removes a single window style.

## ◆ SetTextColour()

void wxListCtrl::SetTextColour | ( | const wxColour & | col | ) |

Sets the text colour of the list control.

## ◆ SetWindowStyleFlag()

void wxListCtrl::SetWindowStyleFlag | ( | long | style | ) |
| virtual

Sets the whole window style, deleting all items.

Reimplemented from wxWindow.

## ◆ SortItems()

bool wxListCtrl::SortItems | ( | wxListCtrlCompare | fnSortCallBack,
|  | wxIntPtr | data )

Call this function to sort the items in the list control.

Sorting is done using the specified fnSortCallBack function. This function must have the following prototype:

int wxCALLBACK wxListCompareFunction(wxIntPtr item1, wxIntPtr item2, wxIntPtr sortData)
wxIntPtr
ssize_t wxIntPtr
Signed and unsigned integral types big enough to contain all of long, size_t and void*.
Definition defs.h:1391

It is called each time when the two items must be compared and should return 0 if the items are equal, negative value if the first item is less than the second one and positive value if the first one is greater than the second one (the same convention as used by `qsort(3)`).

The parameter item1 is the client data associated with the first item (NOT the index). The parameter item2 is the client data associated with the second item (NOT the index). The parameter data is the value passed to SortItems() itself.

Notice that the control may only be sorted on client data associated with the items, so you must use SetItemData if you want to be able to sort the items in the control.

Please see the page_samples_listctrl for an example of using this function.

wxPerl Note: In wxPerl the comparison function must take just two parameters; however, you may use a closure to achieve an effect similar to the SortItems third parameter.